/* ./tty.c :  entry=tty */
/* compiled by EusLisp 9.29() for Linux created on ip-10-0-1-213(Mon Sep 26 11:52:47 PST 2022) */
#include "eus.h"
#include "tty.h"
#pragma init (register_tty)
extern double fabs();
extern pointer fcallx();
static void init_ftab();
extern pointer loadglobal(),storeglobal();
static pointer module,*qv,codevec,quotevec;
extern pointer ___tty();
extern pointer build_quote_vector();
static int register_tty()
  { add_module_initializer("___tty", ___tty);}

static pointer ttyF4132tty_raw();
static pointer ttyF4133tty_cooked();
static pointer ttyF4134backspace();
static pointer ttyF4135cursor_up();
static pointer ttyF4136cursor_down();
static pointer ttyF4137cursor_forward();
static pointer ttyF4138cursor_backward();
static pointer ttyF4139cursor_return();
static pointer ttyF4140cursor_pos();
static pointer ttyF4141erase_eol();

/*tty-raw*/
static pointer ttyF4132tty_raw(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4144;}
	local[0]= makeint((eusinteger_t)0L);
ttyENT4144:
ttyENT4143:
	if (n>1) maerror();
	local[1]= loadglobal(fqv[0]);
	ctx->vsp=local+2;
	w=(pointer)COPYSEQ(ctx,1,local+1); /*copy-seq*/
	local[1]= w;
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)7L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)12L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)13L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)14L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)15L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)21L);
	local[4]= makeint((eusinteger_t)1L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[1];
	local[3]= makeint((eusinteger_t)22L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,3,local+2); /*aset*/
	local[2]= local[0];
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(*ftab[0])(ctx,2,local+2,&ftab[0],fqv[1]); /*unix:tcsets*/
	local[0]= w;
ttyBLK4142:
	ctx->vsp=local; return(local[0]);}

/*tty-cooked*/
static pointer ttyF4133tty_cooked(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4147;}
	local[0]= makeint((eusinteger_t)0L);
ttyENT4147:
ttyENT4146:
	if (n>1) maerror();
	local[1]= local[0];
	local[2]= loadglobal(fqv[0]);
	ctx->vsp=local+3;
	w=(*ftab[0])(ctx,2,local+1,&ftab[0],fqv[1]); /*unix:tcsets*/
	local[0]= w;
ttyBLK4145:
	ctx->vsp=local; return(local[0]);}

/*backspace*/
static pointer ttyF4134backspace(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4150;}
	local[0]= makeint((eusinteger_t)1L);
ttyENT4150:
ttyENT4149:
	if (n>1) maerror();
	local[1]= makeint((eusinteger_t)0L);
	local[2]= local[0];
ttyWHL4151:
	local[3]= local[1];
	w = local[2];
	if ((eusinteger_t)local[3] >= (eusinteger_t)w) goto ttyWHX4152;
	local[3]= makeint((eusinteger_t)8L);
	local[4]= loadglobal(fqv[2]);
	ctx->vsp=local+5;
	w=(pointer)WRTBYTE(ctx,2,local+3); /*write-byte*/
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(pointer)ADD1(ctx,1,local+3); /*1+*/
	local[1] = w;
	goto ttyWHL4151;
ttyWHX4152:
	local[3]= NIL;
ttyBLK4153:
	w = NIL;
	local[1]= loadglobal(fqv[2]);
	ctx->vsp=local+2;
	w=(pointer)FINOUT(ctx,1,local+1); /*finish-output*/
	local[0]= w;
ttyBLK4148:
	ctx->vsp=local; return(local[0]);}

/*cursor-up*/
static pointer ttyF4135cursor_up(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4156;}
	local[0]= makeint((eusinteger_t)1L);
ttyENT4156:
ttyENT4155:
	if (n>1) maerror();
	local[1]= loadglobal(fqv[2]);
	local[2]= fqv[3];
	local[3]= makeint((eusinteger_t)27L);
	local[4]= makeint((eusinteger_t)91L);
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)XFORMAT(ctx,5,local+1); /*format*/
	local[1]= loadglobal(fqv[2]);
	ctx->vsp=local+2;
	w=(pointer)FINOUT(ctx,1,local+1); /*finish-output*/
	local[0]= w;
ttyBLK4154:
	ctx->vsp=local; return(local[0]);}

/*cursor-down*/
static pointer ttyF4136cursor_down(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4159;}
	local[0]= makeint((eusinteger_t)1L);
ttyENT4159:
ttyENT4158:
	if (n>1) maerror();
	local[1]= loadglobal(fqv[2]);
	local[2]= fqv[4];
	local[3]= makeint((eusinteger_t)27L);
	local[4]= makeint((eusinteger_t)91L);
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)XFORMAT(ctx,5,local+1); /*format*/
	local[1]= loadglobal(fqv[2]);
	ctx->vsp=local+2;
	w=(pointer)FINOUT(ctx,1,local+1); /*finish-output*/
	local[0]= w;
ttyBLK4157:
	ctx->vsp=local; return(local[0]);}

/*cursor-forward*/
static pointer ttyF4137cursor_forward(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4162;}
	local[0]= makeint((eusinteger_t)1L);
ttyENT4162:
ttyENT4161:
	if (n>1) maerror();
	local[1]= loadglobal(fqv[2]);
	local[2]= fqv[5];
	local[3]= makeint((eusinteger_t)27L);
	local[4]= makeint((eusinteger_t)91L);
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)XFORMAT(ctx,5,local+1); /*format*/
	local[1]= loadglobal(fqv[2]);
	ctx->vsp=local+2;
	w=(pointer)FINOUT(ctx,1,local+1); /*finish-output*/
	local[0]= w;
ttyBLK4160:
	ctx->vsp=local; return(local[0]);}

/*cursor-backward*/
static pointer ttyF4138cursor_backward(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ttyENT4165;}
	local[0]= makeint((eusinteger_t)1L);
ttyENT4165:
ttyENT4164:
	if (n>1) maerror();
	local[1]= loadglobal(fqv[2]);
	local[2]= fqv[6];
	local[3]= makeint((eusinteger_t)27L);
	local[4]= makeint((eusinteger_t)91L);
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)XFORMAT(ctx,5,local+1); /*format*/
	local[1]= loadglobal(fqv[2]);
	ctx->vsp=local+2;
	w=(pointer)FINOUT(ctx,1,local+1); /*finish-output*/
	local[0]= w;
ttyBLK4163:
	ctx->vsp=local; return(local[0]);}

/*cursor-return*/
static pointer ttyF4139cursor_return(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=0) maerror();
	local[0]= loadglobal(fqv[2]);
	local[1]= fqv[7];
	local[2]= makeint((eusinteger_t)13L);
	ctx->vsp=local+3;
	w=(pointer)XFORMAT(ctx,3,local+0); /*format*/
	local[0]= loadglobal(fqv[2]);
	ctx->vsp=local+1;
	w=(pointer)FINOUT(ctx,1,local+0); /*finish-output*/
	local[0]= w;
ttyBLK4166:
	ctx->vsp=local; return(local[0]);}

/*cursor-pos*/
static pointer ttyF4140cursor_pos(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(pointer)NUMEQUAL(ctx,2,local+0); /*=*/
	if (w==NIL) goto ttyIF4168;
	ctx->vsp=local+0;
	w=(pointer)ttyF4139cursor_return(ctx,0,local+0); /*cursor-return*/
	local[0]= w;
	goto ttyIF4169;
ttyIF4168:
	local[0]= loadglobal(fqv[2]);
	local[1]= fqv[8];
	local[2]= makeint((eusinteger_t)13L);
	local[3]= makeint((eusinteger_t)27L);
	local[4]= makeint((eusinteger_t)91L);
	local[5]= argv[0];
	ctx->vsp=local+6;
	w=(pointer)XFORMAT(ctx,6,local+0); /*format*/
	local[0]= w;
ttyIF4169:
	local[0]= loadglobal(fqv[2]);
	ctx->vsp=local+1;
	w=(pointer)FINOUT(ctx,1,local+0); /*finish-output*/
	local[0]= w;
ttyBLK4167:
	ctx->vsp=local; return(local[0]);}

/*erase-eol*/
static pointer ttyF4141erase_eol(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=0) maerror();
	local[0]= loadglobal(fqv[2]);
	local[1]= fqv[9];
	local[2]= makeint((eusinteger_t)27L);
	local[3]= makeint((eusinteger_t)91L);
	ctx->vsp=local+4;
	w=(pointer)XFORMAT(ctx,4,local+0); /*format*/
	local[0]= loadglobal(fqv[2]);
	ctx->vsp=local+1;
	w=(pointer)FINOUT(ctx,1,local+0); /*finish-output*/
	local[0]= w;
ttyBLK4170:
	ctx->vsp=local; return(local[0]);}

/* initializer*/
pointer ___tty(ctx,n,argv,env)
register context *ctx; int n; pointer *argv; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv;
  register int i;
  numunion nu;
  module=argv[0];
  quotevec=build_quote_vector(ctx,QUOTE_STRINGS_SIZE, quote_strings);
  module->c.code.quotevec=quotevec;
  codevec=module->c.code.codevec;
  fqv=qv=quotevec->c.vec.v;
  init_ftab();
	local[0]= fqv[10];
	ctx->vsp=local+1;
	w=(pointer)EXPORT(ctx,1,local+0); /*export*/
	ctx->vsp=local+0;
	compfun(ctx,fqv[11],module,ttyF4132tty_raw,fqv[12]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[13],module,ttyF4133tty_cooked,fqv[14]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[15],module,ttyF4134backspace,fqv[16]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[17],module,ttyF4135cursor_up,fqv[18]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[19],module,ttyF4136cursor_down,fqv[20]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[21],module,ttyF4137cursor_forward,fqv[22]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[23],module,ttyF4138cursor_backward,fqv[24]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[25],module,ttyF4139cursor_return,fqv[26]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[27],module,ttyF4140cursor_pos,fqv[28]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[29],module,ttyF4141erase_eol,fqv[30]);
	local[0]= fqv[31];
	local[1]= fqv[32];
	ctx->vsp=local+2;
	w=(*ftab[1])(ctx,2,local+0,&ftab[1],fqv[33]); /*provide*/
	local[0]= NIL;
	ctx->vsp=local; return(local[0]);}
static void init_ftab()
{  register int i;
  for (i=0; i<2; i++) ftab[i]=fcallx;
}
